Subject: Re: racing ndo_open()/phylink*connect() with phy_probe()

From: "Russell King (Oracle)" <[email-masked]>
Date: Wed, 1 May 2024 16:19:16 +0100

On Wed, May 01, 2024 at 05:07:44PM +0200, Andrew Lunn wrote:
> On Tue, Apr 30, 2024 at 04:02:19PM -0500, Andrew Halaney wrote:
> > Hi,
> > 
> > I've been taking a look at the following error message:
> > 
> >     qcom-ethqos 23000000.ethernet end1: __stmmac_open: Cannot attach to PHY (error: -19)
> > 
> > end1 is using a phy on the mdio bus of end0, not on its own bus. Something
> > like this devicetree snippet highlights the relationship:
> > 
> >     // end0
> >     &ethernet0 {
> >             phy-mode = "sgmii";
> >             phy-handle = <&sgmii_phy0>;
> > 
> >             mdio {
> >                     compatible = "snps,dwmac-mdio";
> >                     sgmii_phy0: phy@8 {
> >                             compatible = "ethernet-phy-id0141.0dd4";
> >                             reg = <0x8>;
> >                             device_type = "ethernet-phy";
> >                     };
> > 
> >                     sgmii_phy1: phy@a {
> >                             compatible = "ethernet-phy-id0141.0dd4";
> >                             reg = <0xa>;
> >                             device_type = "ethernet-phy";
> >                     };
> >             };
> >     };
> > 
> >     // end1
> >     &ethernet1 {
> >             phy-mode = "sgmii";
> >             phy-handle = <&sgmii_phy1>;
> >     };
> 
> I agree with Russell here. You need to determine where the ENODEV
> comes from.
> 
> It seems unlikely, but one possibility is:
> 
> static int stmmac_xgmac2_mdio_read_c22(struct mii_bus *bus, int phyaddr,
>                                        int phyreg)
> {
>         struct net_device *ndev = bus->priv;
>         struct stmmac_priv *priv;
>         u32 addr;
> 
>         priv = netdev_priv(ndev);
> 
>         /* Until ver 2.20 XGMAC does not support C22 addr >= 4 */
>         if (priv->synopsys_id < DWXGMAC_CORE_2_20 &&
>             phyaddr > MII_XGMAC_MAX_C22ADDR)
>                 return -ENODEV;
> 
> Maybe if the interface is down, priv->synopsys_id has not been set
> yet? Your devices are at address 8 and 10, so if priv->synopsys_id
> where 0, this would give you the ENODEV.

Yes, I did look at that, but didn't read the DT snippet to realise
that the addresses would be trapped by that. So, looking at where
priv->synopsys_id is set... is in stmmac_hwif_init(), which is
called from stmmac_hw_init(), which in turn is called from
stmmac_dvr_probe(). This is the only path that leads here.

This all happens before the MDIO bus is registered, so the value of
priv->synopsys_id should be set by the time the MDIO bus is registered.

So I'm unconvinced... but I think Andrew Halaney needs to delve
deeper into debugging what is going on when the failure occurs.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!